<template>
  <h5>Lubicie się</h5>
  <div class="persons-wrapper">
    <i
      style="
        font-size: 20px !important;
        transform: translate(89vw, -20px) !important;
      "
      class="fa-solid fa-xmark"
      @click="emit('close')"
    ></i>
    <PersonComponent :data="userAsData" />
    <PersonComponent :data="props.person" />"
  </div>
  <InputComponent @content="setContent" />
  <q-btn flat dense round icon="send" aria-label="Menu" @click="sendMessage" />
</template>
<script setup lang="ts">
import { ref } from 'vue';
import { useUserStore } from '../stores/user';
import { useSocketStore } from 'src/stores/socket';
import PersonComponent from './PersonComponent.vue';
import InputComponent from './InputComponent.vue';

defineOptions({ name: 'MatchedComponent' });
const emit = defineEmits(['close']);
interface Person {
  nick: string;
  age: number;
  image: string;
  lazyImage: string;
  city: string;
  loggedIn: boolean;
}
export interface MatchedComponentProps {
  person: Person;
}

const userStore = useUserStore();
const { user } = userStore;

const socketStore = useSocketStore();
const { ws } = socketStore;

const props = withDefaults(defineProps<MatchedComponentProps>(), {});
const userAsData = ref<{
  loggedIn: boolean;
  age: number;
  nick: string;
  image: string;
}>({
  loggedIn: user.loggedIn,
  age: user.age,
  nick: user.nick,
  image: user.photos.profile,
});
const content = ref<string>('');

function sendMessage() {
  ws?.send(
    JSON.stringify({
      message: {
        [props.person.nick]: JSON.stringify({
          datetime: new Date().toISOString().slice(0, 19).replace('T', ' '),
          nick: props.person.nick,
          content: content.value,
        }),
        from: user.uuid,
      },
    })
  );
  setContent('');
}
function setContent(newContent: string) {
  content.value = newContent;
}
</script>
<style scoped lang="scss">
h5 {
  display: flex;
  justify-content: center;
}
.persons-wrapper {
  display: flex;
  flex-direction: row;
}
</style>
